<?php

class ControllerModuleNewsletter extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('module/newsletter');
        $this->document->addScript('view/public/js/module/newsletter.js');


        $this->document->setTitle($this->language->get('heading_title_doc'));

        $this->load->model('setting/setting');
        $this->load->type('tipocomum');
        $this->load->helper('ftr_geral');

        $this->data['ftr_geral'] = new ftr_geral();
        $this->data['Type_Status'] = $this->load->typeForTwig('Type_Status');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {

            $newsletter = array();

            if (isset($this->request->post['newsletter_status'])) {
                $newsletter["newsletter_status"] = $this->request->post['newsletter_status'];
            }

            if (isset($this->request->post['newsletter_name']) && $this->request->post['newsletter_name']) {
                $newsletter["newsletter_name"] = Type_Status::Tp_Habilitado;
            } else {
                $newsletter["newsletter_name"] = Type_Status::Tp_Desabilitado;
            }

            $newsletter['newsletter_fc'] = array(
                "mensagem" => $this->language->get('newsletterfc_text_mensagem'),
                "info" => $this->language->get('newsletterfc_text_informacao'),
                "placeholder_email" => $this->language->get('newsletterfc_text_placeholder_email'),
                "placeholder_name" => $this->language->get('newsletterfc_text_placeholder_name'),
                "text_button" => $this->language->get('newsletterfc_button_add')
            );

            if (isset($this->request->post['newsletterfc_status']) && $this->request->post['newsletterfc_status']) {
                $newsletter['newsletter_fc']['status'] = Type_Status::Tp_Habilitado;
            } else {
                $newsletter['newsletter_fc']['status'] = Type_Status::Tp_Desabilitado;
            }

            $this->model_setting_setting->editSetting('newsletter', $newsletter);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'));
        }

        $this->data['token'] = $this->session->data['token'];
        $this->data['cancel'] = $this->url->link('index', 'token=' . $this->session->data['token'], 'SSL');

        // declaração das variaveis, pegando o nome expresso na linguagem
        $this->data['button_save']      	 		   = $this->language->get('button_save');
        $this->data['button_cancel']  		 		   = $this->language->get('button_cancel');
        $this->data['heading_title']  		 		   = $this->language->get('heading_title');

        $this->data['text_newsletter_status'] = $this->language->get('text_newsletter_status');
        $this->data['text_name'] = $this->language->get('text_name');
        $this->data['text_fc_newsletter'] = $this->language->get('text_fc_newsletter');

        //ate aqui

        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }

        if (isset($this->session->data['success'])) {
    	    $this->data['success'] = $this->session->data['success'];
            unset($this->session->data['success']);
  	    } else {
  	        $this->data['success'] = '';
  	    }

        if (isset($this->request->post['newsletter_status'])) {
            $this->data['newsletter_status'] = $this->request->post['newsletter_status'];
        } else {
            $this->data['newsletter_status'] = $this->config->get('newsletter_status');
    	}

        if (isset($this->request->post['newsletter_name'])) {
            $this->data['newsletter_name'] = $this->request->post['newsletter_name'];
        } else {
            $this->data['newsletter_name'] = $this->config->get('newsletter_name');
        }

        if (isset($this->request->post['newsletter_fc_status'])) {
            $this->data['newsletter_fc_status'] = $this->request->post['newsletter_fc_status'];
        } else {
            $fc =$this->config->get('newsletter_fc');
            if (isset($fc['status'])) {
                $this->data['newsletter_fc_status'] = $fc['status'];
            }
        }


        $this->data['breadcrumbs'] = array();
        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/newsletter', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['action'] = $this->url->link('module/newsletter', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');
        $this->data['cancel'] = $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL');

        $this->children = array(
            'common/header',
            'common/footer',
        );

        $this->response->setOutput($this->render('module/newsletter'));
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'module/newsletter')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

  }
